﻿// CodeGear C++Builder
// Copyright (c) 1995, 2020 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ADOConWizard.pas' rev: 34.00 (Windows)

#ifndef AdoconwizardHPP
#define AdoconwizardHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <Winapi.Windows.hpp>
#include <Winapi.Messages.hpp>
#include <System.SysUtils.hpp>
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Data.Win.ADODB.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.Forms.hpp>

//-- user supplied -----------------------------------------------------------

//-- forward type declarations -----------------------------------------------
class DELPHICLASS TADOConWizard;
//-- type declarations -------------------------------------------------------
enum DECLSPEC_DENUM TProviderType : unsigned char { ptNone, ptMSDA, ptJET, ptACE, ptSQLOLEDB };

enum DECLSPEC_DENUM TConnectionEvent : unsigned char { AfterConnecting, AfterLogin, AfterOpening };

typedef Set<TConnectionEvent, TConnectionEvent::AfterConnecting, TConnectionEvent::AfterOpening> TConnectionEvents;

typedef void __fastcall (__closure *TOnInfo)(TObject* Sender, UnicodeString Info);

typedef void __fastcall (__closure *TOnGetDBFilePassword)(TObject* Sender, UnicodeString &UserID, UnicodeString &Password);

typedef void __fastcall (__closure *TOnLoginUser)(TObject* Sender, bool &Logon);

typedef void __fastcall (__closure *TOnOpenTables)(TObject* Sender, bool &Opened);

class PASCALIMPLEMENTATION TADOConWizard : public TComponent
{
	typedef TComponent inherited;
	
	
private:
	typedef System::StaticArray<UnicodeString, 5> _TADOConWizard__1;
	
	
private:
	TOpenDialog* OpenDlg;
	bool WasCon;
	TProviderType ProviderType;
	TADOConnection* FADOConnection;
	UnicodeString FDefaultDBFile;
	UnicodeString FUDLFilePath;
	UnicodeString FUDLFileMask;
	TConnectionEvents FErrDialogShow;
	bool FLogDetails;
	TOnInfo FOnInfo;
	TOnGetDBFilePassword FOnGetDBFilePassword;
	TOnLoginUser FOnLoginUser;
	TOnOpenTables FOnOpenTables;
	void __fastcall Info(UnicodeString s);
	void __fastcall FindUDLFiles(TStringList* List);
	TProviderType __fastcall GetProviderType(UnicodeString ConStr);
	UnicodeString __fastcall FindConStr(UnicodeString UDLFile);
	UnicodeString __fastcall FormatConStr(UnicodeString ConStr, UnicodeString FileName);
	UnicodeString __fastcall GetFileName(UnicodeString ConStr);
	UnicodeString __fastcall GetConnectedFile();
	bool __fastcall OpenAll_Sel(UnicodeString FileName);
	bool __fastcall OpenAll(UnicodeString SelectedFile);
	bool __fastcall CheckPsw();
	bool __fastcall OpenTables();
	
protected:
	void __fastcall SetADOConnection(TADOConnection* Value);
	virtual void __fastcall Notification(TComponent* AComponent, TOperation Operation);
	
public:
	UnicodeString idProviderStr;
	UnicodeString idEndStr;
	_TADOConWizard__1 idProvider;
	_TADOConWizard__1 idDBFile;
	_TADOConWizard__1 idDefaultDir;
	_TADOConWizard__1 idPsw;
	TStringList* LogText;
	__fastcall virtual TADOConWizard(TComponent* AOwner);
	__fastcall virtual ~TADOConWizard();
	virtual void __fastcall Loaded();
	bool __fastcall ConnectToStr(UnicodeString ConStr);
	bool __fastcall ConnectToFile(UnicodeString DBFileName, bool UseUDLFiles);
	bool __fastcall Connect();
	void __fastcall Disconnect();
	bool __fastcall OpenAll_LastFile();
	bool __fastcall OpenAll_SelectFile();
	bool __fastcall OpenAll_ToFile(UnicodeString FileName);
	bool __fastcall CreateUDLFile();
	bool __fastcall SaveLog(UnicodeString &LogFileName);
	
__published:
	__property TADOConnection* ADOConnection = {read=FADOConnection, write=SetADOConnection};
	__property UnicodeString DefaultDBFile = {read=FDefaultDBFile, write=FDefaultDBFile};
	__property UnicodeString UDLFilePath = {read=FUDLFilePath, write=FUDLFilePath};
	__property UnicodeString UDLFileMask = {read=FUDLFileMask, write=FUDLFileMask};
	__property UnicodeString ConnectedFile = {read=GetConnectedFile};
	__property bool LogDetails = {read=FLogDetails, write=FLogDetails, default=0};
	__property TConnectionEvents ErrDialogShow = {read=FErrDialogShow, write=FErrDialogShow, default=7};
	__property TOnInfo OnInfo = {read=FOnInfo, write=FOnInfo};
	__property TOnGetDBFilePassword OnGetDBFilePassword = {read=FOnGetDBFilePassword, write=FOnGetDBFilePassword};
	__property TOnLoginUser OnLoginUser = {read=FOnLoginUser, write=FOnLoginUser};
	__property TOnOpenTables OnOpenTables = {read=FOnOpenTables, write=FOnOpenTables};
};


//-- var, const, procedure ---------------------------------------------------
extern DELPHI_PACKAGE void __fastcall Register();
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// AdoconwizardHPP
