unit f_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AsBarCode_interface, StdCtrls, ExtCtrls, PropSaveMain, Clipbrd,
  rImprovedComps, rHTMLLabel, ImgList;

type
  TMain = class(TForm)
    bcType: TRadioGroup;
    img: TImage;
    FontDlg: TFontDialog;
    PropSaveFile1: TPropSaveFile;
    PropSaveMain1: TPropSaveMain;
    btCopy: TButton;
    btSave: TButton;
    GroupBox1: TGroupBox;
    btGen: TButton;
    eCode: TEdit;
    chCheckSum: TCheckBox;
    chShowCode: TCheckBox;
    Label1: TLabel;
    chBorder: TCheckBox;
    eBorder: TrEditNum;
    lblAuthor: TrHTMLLabel;
    ImgList: TImageList;
    procedure btGenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bcTypeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btCopyClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure eCodeChange(Sender: TObject);
  private
    B: TBitmap;
  public
  end;

var
  Main: TMain;

implementation

{$R *.dfm}
uses rtool, rpictool;

procedure TMain.FormCreate(Sender: TObject);
begin
  B:=TBitmap.Create;
  GetBarCodeNames(bcType.Items);
end;

procedure TMain.FormDestroy(Sender: TObject);
begin
  B.Free;
end;

procedure TMain.FormShow(Sender: TObject);
begin
  bcTypeClick(nil);
  eCodeChange(nil);
end;

procedure TMain.bcTypeClick(Sender: TObject);
begin
  chCheckSum.Enabled:=TBarcodeType(bcType.ItemIndex) in BCCheckSumType;
end;

procedure TMain.eCodeChange(Sender: TObject);
begin
  btGen.Enabled:=eCode.Text <> '';
end;

procedure TMain.btGenClick(Sender: TObject);
var
  R: TRect;
  linew, w, h, sp: integer;
begin
  if eCode.Text = '' then
    Exit;
  if chBorder.Checked then
    sp:=eBorder.AsInteger
  else
    sp:=0;

  B.SetSize(0, 0);
  B.SetSize(300, 200);

  R.Left:=sp;
  R.Top:=sp;
  R.Right:=B.Width - 2 * sp;
  R.Bottom:=B.Height - 2 * sp;
  linew:=2;

  AsBarCode_interface.DrawBarCode(eCode.Text, TBarcodeType(bcType.ItemIndex), B.Canvas, R, linew, FontDlg.Font, true, chShowCode.Checked, stpBottomCenter,
    chCheckSum.Checked);

  w:=R.Right - R.Left + 2 * sp;
  h:=R.Bottom - R.Top + 2 * sp;
  B.SetSize(w, h);

  img.Picture:=nil;
  img.Width:=w;
  img.Height:=h;
  img.Picture.Assign(B);

  btCopy.Enabled:=true;
  btSave.Enabled:=true;
end;

procedure TMain.btCopyClick(Sender: TObject);
begin
  Clipbrd.Clipboard.Assign(B);
end;

procedure TMain.btSaveClick(Sender: TObject);
begin
  rpictool.SaveDlg_PictureToFile(img.Picture, GetAppDir, gtBMP);
end;

end.
