unit f_checkRTF;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, ExtCtrls, DrpFiles, PropSaveMain,
  Grids, ValEdit, rImprovedComps, rHTMLLabel;

type
  TMain = class(TForm)
    OpenDlg: TOpenDialog;
    PropSaveFile1: TPropSaveFile;
    PropSaveMain1: TPropSaveMain;
    gbFiles: TrGroupBox;
    lb: TListBox;
    rGroupBox2: TrGroupBox;
    rGroupBox1: TrGroupBox;
    pc: TPageControl;
    TabSheet1: TTabSheet;
    tc: TTabControl;
    e: TMemo;
    TabSheet2: TTabSheet;
    vle: TValueListEditor;
    btDelSel: TrButton;
    btDelAll: TrButton;
    btCheckSel: TrButton;
    btCheckAll: TrButton;
    btClearThemeData: TrButton;
    chBackup: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure tcChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure gbFilesDropFiles(Sender: TObject; X, Y: Integer);
    procedure btCheckSelClick(Sender: TObject);
    procedure btCheckAllClick(Sender: TObject);
    procedure btDelSelClick(Sender: TObject);
    procedure btDelAllClick(Sender: TObject);
    procedure OnAbort(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Aborted: boolean;
    FReportFile: string;

    L: array of TStrings;

    function FindTagStr(TagStr: string; var s: string; WChar: Char;
                               var StartPos: integer; Del: boolean): string;
    function ExtractSpecChar(var Str: string): string;
    function ProcRTF(s: string): string;
    procedure ProcAll;
    procedure FreeAll;
    procedure LoadProcFile;
    procedure CheckTags;
    procedure ClearThemeData;
  end;

var
  Main: TMain;

implementation

{$R *.dfm}

uses rstring, rtool, rdlg;

const
  // rtf
  cEOL=#13+#10;
  cTagCh='X';
  cTag='\\X\\';
  cRtfHexMark='\''';

function TMain.FindTagStr(TagStr: string; var s: string; WChar: Char;
                               var StartPos: integer; Del: boolean): string;
var sd,fd: integer;
    p1,p2: string;
begin
  Result:='';
  sd:=StartPos;
  StartPos:=0;
  p1:=copy(TagStr,1,AnsiPos(WChar,TagStr)-1);
  if p1='' then Exit;
  sd:=AnsiPosEx(p1,s,sd,false);
  if sd=0 then Exit;
  p2:=copy(TagStr,AnsiPos(WChar,TagStr)+1,Length(TagStr));
  if p2='' then Exit;
  fd:=AnsiPosEx(p2,s,sd+Length(p1),false);
  if fd=0 then Exit;
  Result:=copy(s,sd+Length(p1),fd-sd-Length(p1));
  StartPos:=sd;
  if Del then Delete(s,sd,fd-sd+Length(p2));
end;

function TMain.ExtractSpecChar(var Str: string): string;
var i,p: integer;
begin
  Result:='';
  p:=0;
  for i:=1 to Length(Str) do
    if CharInSet(Str[i],['{','}']) then
    begin
      if p=0 then p:=i
      else p:=-1;
    end;
  if p>0 then
  begin
    Result:=Str[p];
    Delete(Str,p,1);
  end;
end;

function TMain.ProcRTF(s: string): string;
var d,tagpos: integer;
    tagstr,spec: string;
begin
  //proc other tags
  tagpos:=0;
  repeat
    //find tag
    tagstr:=FindTagStr(cTag,s,cTagCh,tagpos,false);
    if tagpos=0 then Break;
    d:=Pos(cTagCh,cTag)-1;
    // skip MSWord field format strins and unussual long TAGS (error)
    try
      if (CharInSet(tagstr[1],['@','*','#'])) or (Length(tagstr)>250) then
      begin
        Inc(tagpos,d);
        Continue;
      end;
    except
    end;
    spec:=ExtractSpecChar(tagstr);

    e.Lines.Add(tagstr);
    d:=length(tagstr)+4;
    Inc(tagpos,d);

    Application.ProcessMessages;
    if Aborted then
    begin
      e.Lines.Add('TERMINATED BY USER');
      Break;
    end;
  until false;
  Result:=s;
end;

procedure TMain.btCheckSelClick(Sender: TObject);
begin
  if (lb.ItemIndex<0) or (lb.ItemIndex>lb.Items.Count-1) then Exit;
  Aborted:=false;
  FreeAll;
  pc.ActivePageIndex:=0;
  gbFiles.Enabled:=false;
  try
    CheckTags;
    pc.ActivePageIndex:=1;
  finally
    gbFiles.Enabled:=true;
  end;
end;

procedure TMain.btCheckAllClick(Sender: TObject);
var i: integer;
begin
  Aborted:=false;
  FreeAll;
  pc.ActivePageIndex:=0;
  gbFiles.Enabled:=false;
  try
    for i:=0 to lb.Items.Count-1 do
    begin
      lb.ItemIndex:=i;
      if Aborted then Break;
      if Sender=btCheckAll then CheckTags
                           else ClearThemeData;
    end;
    pc.ActivePageIndex:=1;
  finally
    gbFiles.Enabled:=true;
  end;
end;

procedure TMain.ClearThemeData;
var RepStr, fn: string;
    p: PChar;
    FS: TFileStream;
    i: integer;
    AStr: AnsiString;
begin
  fn:=lb.Items[lb.itemindex];
  if chBackup.Checked then
    CopyFile(PChar(fn),PChar(ChangeFileExt(fn,'.bup')),false);

  //read report file to string
  try
    FS:=TFileStream.Create(fn,fmOpenRead+fmShareDenyNone);
    try
      SetLength(AStr,FS.Size);
      FS.Read(Pointer(AStr)^,FS.Size);
    finally
      FS.Free;
    end;
  except
    raise Exception.Create(Format(sFileOpenErr,[fn])+#13+sFileOpenErr2);
  end;
  RepStr:=string(AStr);

  i:=AnsiPos('{\*\themedata',RepStr);
  if i>0 then RepStr:=copy(RepStr,1,i-1)+'}';
  AStr:=AnsiString(RepStr);

  try
    FS:=TFileStream.Create(fn,fmCreate);
    try
      FS.Write(Pointer(astr)^,Length(astr));
    finally
      FS.Free;
    end;
  except
    raise Exception.Create(Format(sFileSaveErr,[fn])+#13+sFileSaveErr2);
  end;
end;

procedure TMain.btDelAllClick(Sender: TObject);
begin
  lb.Items.Clear;
end;

procedure TMain.btDelSelClick(Sender: TObject);
begin
  if (lb.ItemIndex<0) or (lb.ItemIndex>lb.Items.Count-1) then Exit;
  lb.Items.Delete(lb.ItemIndex);
end;

procedure TMain.ProcAll;
var RepStr: string;
    p: PChar;
    FS: TFileStream;
    i: integer;
    AStr: AnsiString;
begin
  Application.ProcessMessages;
  //read report file to string
  try
    FS:=TFileStream.Create(FReportFile,fmOpenRead+fmShareDenyNone);
    try
      SetLength(AStr,FS.Size);
      FS.Read(Pointer(AStr)^,FS.Size);
    finally
      FS.Free;
    end;
  except
    raise Exception.Create(Format(sFileOpenErr,[FReportFile])+#13+sFileOpenErr2);
  end;
  RepStr:=string(AStr);

  //remove end of lines
  //s:=ClearStr(cEOL,s,false); => is too slow
  repeat
    i:=Pos(cEOL,RepStr);
    if i=0 then Break;
    Delete(RepStr,i,Length(cEOL));
  until false;

  // proc all report
  RepStr:=ProcRTF(RepStr);
end;

procedure TMain.BitBtn1Click(Sender: TObject);
begin
  if OpenDlg.Execute then
    lb.Items.AddStrings(OpenDlg.Files);
end;

procedure TMain.BitBtn2Click(Sender: TObject);
var s: string;
begin
  if (lb.ItemIndex<0) or (lb.ItemIndex>lb.Items.Count-1) then Exit;
  s:=lb.Items[lb.ItemIndex];
  if s<>'' then rtool.RunFile(s,'','',SW_SHOW);
end;

procedure TMain.BitBtn3Click(Sender: TObject);
begin
  lb.Items.Clear;
  FreeAll;
end;

procedure TMain.FreeAll;
var i: integer;
begin
  e.Lines.Clear;
  tc.Tabs.Clear;
  for i:=0 to High(L) do
    try
      L[i].Free;
    except
    end;
  SetLength(L,0);   
  for i:=vle.RowCount-1 downto 1 do
  try
    vle.DeleteRow(i);
  except
  end;
end;

procedure TMain.gbFilesDropFiles(Sender: TObject; X, Y: Integer);
var i: integer;
begin
  for i := 0 to gbFiles.DropFilesCount- 1 do
    lb.Items.Add(gbFiles.DropFileNames[i]);
end;

procedure TMain.OnAbort(Sender: TObject);
begin
  Aborted:=true;
end;

procedure TMain.LoadProcFile;
var i: integer;
begin
  FReportFile:=lb.Items[lb.itemindex];
  tc.Tabs.Add(ExtractFileName(FReportFile));
  i:=tc.Tabs.Count;
  tc.TabIndex:=i-1;
  e.Lines.Clear;
  ProcAll;
  SetLength(L,i);
  L[i-1]:=TStringList.Create;
  L[i-1].Assign(E.Lines);
end;

procedure TMain.tcChange(Sender: TObject);
begin
  e.Lines.Assign(L[tc.tabIndex]);
end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FreeAll;
end;

procedure TMain.CheckTags;
const
  errch='\{}';
var i,j: integer;
    s: string;
begin
  rdlg.ShowInfoEx('Processing...',self, OnAbort);
  try
    LoadProcFile;

    for i:=0 to e.Lines.Count-1 do
    begin
      s:=e.Lines[i];
      for j:=1 to Length(s) do
      begin
        if Pos(s[j],errch)>0 then
        begin
          vle.InsertRow(tc.Tabs[tc.TabIndex],s,true);
          Break;
        end;
      end;
    end;
  finally
    rdlg.ShowInfo('');
  end;
end;

end.
